# Enum LifecycleState

java.lang.Object
java.lang.Enum<LifecycleState>
org.apache.catalina.LifecycleState

All Implemented Interfaces:
  `Serializable, Comparable<LifecycleState>, java.lang.constant.Constable`

public enum LifecycleState extends Enum<LifecycleState>
The list of valid states for components that implement `Lifecycle`. See `Lifecycle` for the state transition diagram.

## Nested Class Summary

### Nested classes/interfaces inherited from class Enum

`Enum.EnumDesc<E>`

## Enum Constant Summary

Enum Constants
Enum Constant
Description
`DESTROYED`
`DESTROYING`
`FAILED`
`INITIALIZED`
`INITIALIZING`
`NEW`
`STARTED`
`STARTING`
`STARTING_PREP`
`STOPPED`
`STOPPING`
`STOPPING_PREP`

## Method Summary

Modifier and Type
Method
Description
`String`
`getLifecycleEvent()`
`boolean`
`isAvailable()`
May the public methods other than property getters/setters and lifecycle methods be called for a component in this state?
`static LifecycleState`
`valueOf(String name)`
Returns the enum constant of this type with the specified name.
`static LifecycleState[]`
`values()`
Returns an array containing the constants of this enum type, in the order they are declared.

### Methods inherited from class Enum

`clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class Object

`getClass, notify, notifyAll, wait, wait, wait`

## Enum Constant Details

### NEW

public static final LifecycleState NEW

### INITIALIZING

public static final LifecycleState INITIALIZING

### INITIALIZED

public static final LifecycleState INITIALIZED

### STARTING_PREP

public static final LifecycleState STARTING_PREP

### STARTING

public static final LifecycleState STARTING

### STARTED

public static final LifecycleState STARTED

### STOPPING_PREP

public static final LifecycleState STOPPING_PREP

### STOPPING

public static final LifecycleState STOPPING

### STOPPED

public static final LifecycleState STOPPED

### DESTROYING

public static final LifecycleState DESTROYING

### DESTROYED

public static final LifecycleState DESTROYED

### FAILED

public static final LifecycleState FAILED

## Method Details

### values

public static LifecycleState[] values()
Returns an array containing the constants of this enum type, in the order they are declared.

Returns:
  an array containing the constants of this enum type, in the order they are declared

### valueOf

public static LifecycleState valueOf(String name)
Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum type has no constant with the specified name
  `NullPointerException` - if the argument is null

### isAvailable

public boolean isAvailable()
May the public methods other than property getters/setters and lifecycle methods be called for a component in this state? It returns `true` for any component in any of the following states:

- `STARTING`
- `STARTED`
- `STOPPING_PREP`

Returns:
  `true` if the component is available for use, otherwise `false`

### getLifecycleEvent

public String getLifecycleEvent()